import random
import sys


def join_subsets(arff_path, subsets):
    header = []
    data = []
    header_set = False
    for subset in subsets:
        in_data = False
        with open('{}.{}.arff'.format(arff_path, subset)) as f:
            for line in f:
                if not header_set and not in_data:
                    header.append(line.strip())

                if line.strip().lower().startswith('@data'):
                    in_data = True
                    header_set = True

                elif in_data and len(line) > 10:
                    data.append(line.strip())

    with open('{}.joined.arff'.format(arff_path), 'w') as f:
        for line in header:
            print(line, file=f)
        for line in data:
            print(line, file=f)


def split_dataset(arff_path, fold, total_folds=10, seed=42):
    header = []
    data = []
    in_data = False
    with open(arff_path) as f:
        for line in f:
            if not in_data:
                header.append(line.strip())
            if line.strip().lower().startswith('@data'):
                in_data = True
            elif in_data and len(line) > 10:
                data.append(line.strip())

    random.seed(seed)
    random.shuffle(data)

    with open('{}.fold{}.test'.format(arff_path, fold), 'w') as f:
        with open('{}.fold{}.train'.format(arff_path, fold), 'w') as g:
            for line in header:
                print(line, file=f)
                print(line, file=g)

            for i, line in enumerate(data):
                if i % total_folds == fold:
                    print(line, file=f)
                else:
                    print(line, file=g)


if __name__ == '__main__':
    split_dataset(sys.argv[1], int(sys.argv[2]))
