
# Auxiliary functions
def get_trainset_size(lines):
    i = lines.index('Training error\n')
    return int(lines[i+3].strip().split()[-1])


def find_line(lines,tags):
    i=0
    for tag in tags:
        while tag not in lines[i]: i+=1
    return lines[i]


def get_error(lines,tags):
    return float(find_line(lines,tags).strip().split()[-1])

def get_error_per_target(lines,tags):
    return eval(find_line(lines,tags).strip().split(':')[1])

def get_matrix(lines,tags):
    i=0
    for tag in tags:
        try:
            while tag not in lines[i]: i+=1
        except IndexError:
            print('Cannot find tag: ',tag)
            1//0
    matrix = []
    n = len(lines[i+2].strip().split('|'))-2
    for j in range(n):
        lst = map(int,lines[i+4+j].strip().split('|')[1:-1])
        matrix.append(list(lst))
    return matrix

def get_some_leaves(lines,tags):
    return int(find_line(lines,tags).strip().split()[-1].strip(')'))


def get_time(lines):
    i=0
    while 'Induction Time:' not in lines[i]: i+=1
    t1 = float(lines[i].split()[-2])
    t2 = float(lines[i+1].split()[-2])
    return t1+t2

# Find errors
def get_default_trainrmse(lines):
    return get_error_per_target(lines,['Training error','Root mean squared','Default'])

def get_original_trainrmse(lines):
    return get_error_per_target(lines,['Training error','Root mean squared','Original'])

def get_pruned_trainrmse(lines):
    return get_error_per_target(lines,['Training error','Root mean squared','Pruned'])

def get_default_testrmse(lines):
    return get_error_per_target(lines,['Testing error','Root mean squared','Default'])

def get_original_testrmse(lines):
    return get_error_per_target(lines,['Testing error','Root mean squared','Original'])

def get_pruned_testrmse(lines):
    return get_error_per_target(lines,['Testing error','Root mean squared','Pruned'])

def get_HMLC_AUPRC(lines):
    return get_error(lines,['Testing error','Hierarchical error measures','Average AUPRC:'])

def get_HMLC_AUROC(lines):
    return get_error(lines,['Testing error','Hierarchical error measures','Average AUROC'])

def get_HMLC_pooled_AUPRC(lines):
    return get_error(lines,['Testing error','Hierarchical error measures','Pooled AUPRC'])

def get_HMLC_weighted_AUPRC(lines):
    return get_error(lines,['Testing error','Hierarchical error measures','Average AUPRC (weighted)'])

def get_MLC_AUPRC(lines):
    return get_error(lines,['Testing error','averageAUPRC','Original'])

def get_MLC_AUROC(lines):
    return get_error(lines,['Testing error','averageAUROC','Original'])

def get_MLC_pooled_AUPRC(lines):
    return get_error(lines,['Testing error','pooledAUPRC','Original'])

def get_MLC_weighted_AUPRC(lines):
    return get_error(lines,['Testing error','weightedAUPRC','Original'])


def get_pruned_MLC_AUPRC(lines):
    return get_error(lines,['Testing error','averageAUPRC','Pruned'])

def get_pruned_MLC_AUROC(lines):
    return get_error(lines,['Testing error','averageAUROC','Pruned'])

def get_pruned_MLC_pooled_AUPRC(lines):
    return get_error(lines,['Testing error','pooledAUPRC','Pruned'])

def get_pruned_MLC_weighted_AUPRC(lines):
    return get_error(lines,['Testing error','weightedAUPRC','Pruned'])



# Find model size
def get_original_leaves(lines):
    return get_some_leaves(lines,['Model information', 'Original: Nodes'])


def get_pruned_leaves(lines):
    return get_some_leaves(lines,['Model information', 'Pruned: Nodes'])

def get_forest_leaves(lines):
    return get_some_leaves(lines,['Model information','Original: FOREST'])

def get_n_trees_leaves(lines,n):
    return get_some_leaves(lines,['Model information','Forest with {} trees'.format(n)])


def get_unlabeled_size(lines):
    i = lines.index('Default Model\n')
    total = int(lines[i+3].strip().split()[-1])
    return total - get_trainset_size(lines)

def get_tree_numbers(lines):
    i = 0
    while 'Model information' not in lines[i]:
        i += 1
    i += 2
    num_trees = []
    while 'Forest with' in lines[i]:
        num_trees.append(int(lines[i].split()[2]))
        i += 1
    return num_trees
